----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:39:32 08/06/2014 
-- Design Name: 
-- Module Name:    SegCounter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity SegCounter is
Port 
( 
	clk : in  STD_LOGIC;
   clr : in  STD_LOGIC;
   seg : out STD_LOGIC_VECTOR (6 downto 0);
   an  : out STD_LOGIC_VECTOR (3 downto 0);
   dp  : out STD_LOGIC
);
end SegCounter;

architecture Behavioral of SegCounter is
	
	component CLKCounter
	Port 
	( 
		clk      : in  STD_LOGIC;
		CLK_CNT  : out  STD_LOGIC;
		CLK_DISP : out  STD_LOGIC
	);
	end component;
	
	component Counter
	Port
	( 
		CLK_CNT : in  STD_LOGIC;
		clr     : in  STD_LOGIC;
		x       : out  STD_LOGIC_VECTOR (3 downto 0)
	);
	end component;
	
	component PositionValueCounter
	Port 
	( 
		x       : in  STD_LOGIC_VECTOR (3 downto 0);
		CLK_CNT : in  STD_LOGIC;
		y0      : out  STD_LOGIC_VECTOR (3 downto 0);
		y1      : out  STD_LOGIC
	);
	end component;
	
	component Position0Display
	Port
	( 
		y0   : in  STD_LOGIC_VECTOR (3 downto 0);
		seg0 : out  STD_LOGIC_VECTOR (6 downto 0)
	);
	end component;
	
	component Position1Display
	Port
	( 
		y1   : in  STD_LOGIC;
		seg1 : out  STD_LOGIC_VECTOR (6 downto 0)
	);
	end component;
	
	component DisplayController
	Port 
	( 
		seg0     : in  STD_LOGIC_VECTOR (6 downto 0);
		seg1     : in  STD_LOGIC_VECTOR (6 downto 0);
		CLK_DISP : in  STD_LOGIC;
		seg      : out  STD_LOGIC_VECTOR (6 downto 0);
		an       : out  STD_LOGIC_VECTOR (3 downto 0);
		dp       : out  STD_LOGIC
	);
	end component;
	
	signal CLK_CNT_signal  : STD_LOGIC;
	signal CLK_DISP_signal : STD_LOGIC;
	signal x_signal        : STD_LOGIC_VECTOR(3 downto 0);
	signal y0_signal       : STD_LOGIC_VECTOR(3 downto 0);
	signal y1_signal       : STD_LOGIC;
	signal seg0_signal     : STD_LOGIC_VECTOR(6 downto 0);
	signal seg1_signal     : STD_LOGIC_VECTOR(6 downto 0);

begin

	CLK_CNT : CLKCounter
	port map
	(
		clk      => clk,
		CLK_CNT  => CLK_CNT_signal,
		CLK_DISP => CLK_DISP_signal
	);
	
	CNT : Counter
	port map
	(
		CLK_CNT => CLK_CNT_signal,
		clr     => clr,
		x       => x_signal
	);
	
	POS_VAL_CNT : PositionValueCounter
	port map 
	( 
		x       => x_signal,
		CLK_CNT => CLK_CNT_signal,
		y0      => y0_signal,
		y1      => y1_signal
	);
	
	POS_0_DISP : Position0Display
	port map
	( 
		y0   => y0_signal,
		seg0 => seg0_signal
	);
	
	POS_1_DISP : Position1Display
	port map
	( 
		y1   => y1_signal,
		seg1 => seg1_signal
	);
	
	DISP_CNTRL : DisplayController
	port map 
	( 
		seg0     => seg0_signal,
		seg1     => seg1_signal,
		CLK_DISP => CLK_DISP_signal,
		seg      => seg,
		an       => an,
		dp       => dp
	);

end Behavioral;